// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {
    rigidBody: cc.RigidBody;
    collider: cc.PhysicsPolygonCollider;


    // LIFE-CYCLE CALLBACKS:

    onLoad () {
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        this.rigidBody.angularVelocity = 100;
        // this.motor.connectedBody
        // this.collider =this.node.getComponent(cc.PhysicsPolygonCollider);
        // const collisionManager = cc.director.getCollisionManager();
        // collisionManager.enabled = true;
    }

    onPreSolve(contact, selfCollider, otherCollider) {
        // console.error(otherCollider.node.name);
        // if (otherCollider && otherCollider.node.getComponent(cc.MotorJoint)) {
        //     // this.rigidBody.awake = false;
        //     console.error(selfCollider.name);
        //     otherCollider.node.addComponent(cc.MotorJoint);
        //     const motor = otherCollider.node.getComponent(cc.MotorJoint);
        //     motor.connectedBody = this.node;
        //     motor.maxTorque = -200;
        // }
        // const motorJoint =this.node.getComponent(cc.MotorJoint);
        // motorJoint.connectedBody = otherCollider.node;
        // console.error(motorJoint.connectedBody.name);
        this.rigidBody.linearVelocity =cc.v2(0,0);
        if (otherCollider.node.name.includes('dynamicGear')) {
            this.rigidBody.angularVelocity = - 200 //otherCollider.node.getComponent(cc.RigidBody).angularVelocity;
        }
        }

        onPostSolve(contact, selfCollider, otherCollider) {
            this.rigidBody.angularVelocity = 0;
        }

    start () {

    }

    update (dt) {
        // this.rigidBody.angularVelocity = 200;
    }
}
