// Learn TypeScript:
//  - https://docs.cocos.com/creator/manual/en/scripting/typescript.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

const {ccclass, property} = cc._decorator;

@ccclass
export default class NewClass extends cc.Component {

    @property(cc.Label)
    label: cc.Label = null;

    @property
    text: string = 'hello';
    rigidBody: cc.RigidBody;

    // LIFE-CYCLE CALLBACKS:
    onLoad () {
        this.rigidBody = this.node.getComponent(cc.RigidBody);
        this.rigidBody.type = cc.RigidBodyType.Dynamic;
    }

    start () {

    }

    // update (dt) {
    //     this.rigidBody.angularVelocity = 100;
    // }
}
